package at.jku.ssw.worms.score;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.IdentityType;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.datastore.Key;

@PersistenceCapable(identityType = IdentityType.APPLICATION)
public class Score {
    @PrimaryKey
    @Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
    private Key key;

    @Persistent
    private String playerName;

    @Persistent
    private int score;

    public Score(String playerName, int score) {
    	this.setPlayerName(playerName);
    	this.setScore(score);
    }

	public Key getKey() {
		return key;
	}

	private void setPlayerName(String player) {
		this.playerName = player;
	}

	public String getPlayerName() {
		return playerName;
	}
	
	public String getHtmlSafePlayerName() {
		String str = getPlayerName();
		str = str.replaceAll("&", "&amp;");
		str = str.replaceAll("<", "&lt;");
		str = str.replaceAll(">", "&gt;");
		str = str.replaceAll("\"", "&quot;");
		return str;
	}

	public void setScore(int score) {
		this.score = score;
	}

	public int getScore() {
		return score;
	}    
}
