package at.jku.ssw.worms.score;

import java.util.List;

import javax.jdo.PersistenceManager;
import javax.jdo.Query;

public class ScoreUtil {
	private static final String SELECT_TOP_10 = "select from "
			+ Score.class.getName() + " order by score desc range 0,10";
	private static final String SELECT_PLAYER = "select from "
			+ Score.class.getName() + " where playerName == name";

	private ScoreUtil() {
		// keep private
	}

	public static List<Score> getScores() {
		PersistenceManager pm = PersistenceManagerFactoryProvider.get()
				.getPersistenceManager();
		try {
			@SuppressWarnings("unchecked")
			List<Score> scores = (List<Score>) pm.newQuery(SELECT_TOP_10)
					.execute();
			return (List<Score>) pm.detachCopyAll(scores);
		} finally {
			pm.close();
		}
	}

	public static Score getScore(String name) {
		PersistenceManager pm = PersistenceManagerFactoryProvider.get()
				.getPersistenceManager();
		try {
			return getScore(name, pm);
		} finally {
			pm.close();
		}
	}

	public static void putScoreIntoDatabase(String name, int score) {
		PersistenceManager pm = PersistenceManagerFactoryProvider.get()
				.getPersistenceManager();
		try {
			Score s = getScore(name, pm);
			if (s == null) {
				s = new Score(name, score);
				pm.makePersistent(s);
			} else if (score > s.getScore()) {
				s.setScore(score);
			}
		} finally {
			pm.close();
		}
	}

	private static Score getScore(String name, PersistenceManager pm) {
		Query query = pm.newQuery(SELECT_PLAYER);
		query.declareImports("import java.lang.String");
		query.declareParameters("java.lang.String name");
		@SuppressWarnings("unchecked")
		List<Score> score = (List<Score>) query.execute(name);
		return (score.size() == 1) ? score.get(0) : null;
	}
}
